package com.jiuqi.grid;

import com.jiuqi.util.MemStream;
import com.jiuqi.util.Stream;
import com.jiuqi.util.StreamException;
import java.io.Serializable;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Map;

public class ExtendedDatas implements Serializable, Cloneable {
   private Hashtable extDatas = new Hashtable();

   public byte[] getData(String name) {
      return (byte[])this.extDatas.get(name);
   }

   public void setData(String name, byte[] data) {
      if (data != null && data.length != 0) {
         this.extDatas.put(name, data);
      } else {
         this.extDatas.remove(name);
      }

   }

   public void setData(String name, int[] data) {
      if (data != null && data.length != 0) {
         MemStream stream = new MemStream();

         try {
            for(int i = 0; i < data.length; ++i) {
               stream.writeInt(data[i]);
            }

            this.setData(name, stream.getBytes());
         } catch (StreamException var5) {
            StreamException e = var5;
            e.printStackTrace();
         }
      } else {
         this.extDatas.remove(name);
      }

   }

   public void clear() {
      this.extDatas.clear();
   }

   public boolean contains(String name) {
      return this.extDatas.containsKey(name);
   }

   public void loadFromStream(Stream stream, int size) throws StreamException {
      this.clear();

      while(stream.getPosition() < (long)size) {
         int len = stream.readInt();
         String key = stream.readString(len);
         len = stream.readInt();
         byte[] data = new byte[len];
         stream.readBuffer(data, 0, len);
         this.extDatas.put(key, data);
      }

   }

   public void saveToStream(Stream stream) throws StreamException {
      Iterator items = this.extDatas.entrySet().iterator();

      while(items.hasNext()) {
         Map.Entry item = (Map.Entry)items.next();
         String key = (String)item.getKey();
         stream.writeInt(key.length());
         stream.writeString(key);
         byte[] data = (byte[])item.getValue();
         stream.writeInt(data.length);
         stream.writeBuffer(data, 0, data.length);
      }

   }

   protected Object clone() {
      try {
         ExtendedDatas result = (ExtendedDatas)super.clone();
         result.extDatas = new Hashtable(this.extDatas);
         return result;
      } catch (CloneNotSupportedException var2) {
         return null;
      }
   }
}
